## sather-1.3-beta-5.tar.bz2

=== Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

###############################################################################
# Be sure to read the file Doc/Installation!
# You may need to set some variables in System/Common/CONFIG.proto
# to be appropriate to your system.
# Also make sure to adjust the paths in System/Platforms/X/Platform.module
# and System/Platforms/tcltk/Platform.module
###############################################################################

export SATHER_HOME=$(shell pwd)
unexport SATHER_LIBRARY
unexport SATHER_ENV

###############################################################################
# include configuration information

include $(SATHER_HOME)/config.default

##############################################################################
# construct the needed variables

SACOMP          =bin/sacomp
SACOMP_BOOT     =bin/sacomp-boot
SACOMP_BOOT_CODE=bin/sacomp-boot.code
SACOMP_DEBUG    =bin/sacomp-debug
SACOMP_PROFILE  =bin/sacomp-profile
SABROWSE        =bin/sabrowse

CS_OPT        =-verbose -O_fast -O_no_move_while -O_no_hoist_const -O_no_cse -only_reachable -pretty
CS_OPT_DEBUG  =-verbose -chk -debug -debug_deterministic -debug_no_backtrace
CS_OPT_PROFILE=-verbose -only_reachable -optimize -C_flag -pg

################################ DEPENDENCIES #################################

# The compiler which ends up in bin/ is the "fast" executable,
# which means that checking is turned off and optimizations are on.

# Some makes can't expand glob syntax with more than one *, so
# only specify one directory to expand instead of listing all of them.
# Watch out for this if you are modifying the compiler.

# This runs the C compiles after the Sather compiler instead of at
# the same time, to ease installation for those with small VM.

default: $(SACOMP)

$(SACOMP): $(SACOMP_BOOT)
	@echo "**** Creating C for installation compiler *****"
	cp platforms/cygwin/Platform.module-boot platforms/cygwin/Platform.module
#	$(SACOMP_BOOT) $(CS_OPT) sacomp/sacomp.module -o $(SACOMP) -only_C
# Ugly, but the clean solution in sacomp means some work...:
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT) ../sacomp/sacomp.module -o ../$(SACOMP) -only_C
	@echo "***** Compiling C for installation compiler *****"
	$(MAKE) -C $(SACOMP).code
	cp platforms/cygwin/Platform.module-run platforms/cygwin/Platform.module

boot: $(SACOMP_BOOT)

optional: browser tcltk f77

browser: $(SACOMP_BOOT)
	@echo "***** Creating C for Browser *****"
	$(SACOMP_BOOT) $(CS_OPT) auxiliaries/sabrowse/sabrowse.module -o $(SABROWSE) -only_C
	@echo "***** Compiling C for Browser *****"
	$(MAKE) -C $(SABROWSE).code

tcltk: $(SACOMP)
	$(MAKE) -C platforms/X
	$(MAKE) -C platforms/tcltk
	$(MAKE) -C platforms/gui
	$(MAKE) -C platforms/dualgui

f77: $(SACOMP)
	$(MAKE) -C platforms/f77

debug: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT_DEBUG) ../sacomp/sacomp.module -o $(SACOMP_DEBUG) -only_C
	$(MAKE) -C $(SACOMP_DEBUG).code

profile: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP) $(CS_OPT_PROFILE) ../sacomp/sacomp.module -o $(SACOMP_PROFILE) -only_C
	$(MAKE) -C $(SACOMP_PROFILE).code

$(SACOMP_BOOT): system
	@echo; echo "Making boot compiler..." ; echo
	ln -sf ../$(BOOT_PLATFORM)/header.h platforms/BOOT/header.h
	$(MAKE) -C $(SACOMP_BOOT_CODE) $(MAKE_OPT_BOOT)

# The rule for System/Common/CONFIG also makes the serial libraries,
# as well as making any platforms.

system: platforms resources
	$(MAKE) -C system

# The following is only meant for real platforms. Special platforms (gui,
# tcltk, etc.) are made by the "optional" target

platforms:
	for i in `echo "BOOT",$(PLATFORMS) | tr , \ `; do		\
	  echo "Making platform $$i..." ;				\
	  $(MAKE) -C platforms/$$i ;					\
	done

resources:
	for i in $(SATHER_HOME)/resources/*/bin ; do  \
	  $(RM) $$i/$(LIBCHARS) ;                     \
	  $(LN) $(LIBCHARS_VERSION) $$i/$(LIBCHARS) ; \
	done

info:
	cd emacs && makeinfo sather.texinfo
	cd emacs && makeinfo sather-tutorial.texinfo
	cd emacs && makeinfo sather-mode.texinfo

.PHONY: full boot optional tcltk f77 debug profile system platforms info \
test testfull clean-unneeded clean resources info

################################### TESTING ###################################

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full
# double compilation of the compiler, which can take quite a while.

test:
	$(MAKE) -C test test

# The full test does the following:
#
#    1. Compile using Bin/sacomp, with full checking on.
#    2. Compile using result.

testfull:
	$(MAKE) -C test testfull


################################### CLEANING ##################################

clean:
	$(MAKE) -C system clean
	$(MAKE) -C test clean

	for i in platforms/* ; do					\
	  if [ -f $$i/Makefile ] ; then $(MAKE) -C $$i clean ; fi	\
	done;

	$(RM) -r $(SACOMP).code $(SABROWSE).code
	$(RM) -r $(SACOMP_PROFILE).code $(SACOMP_DEBUG).code
	$(RM) $(SACOMP_BOOT).code/*.o
	$(RM) $(SACOMP) $(SACOMP_BOOT) $(SABROWSE)
	$(RM) $(SACOMP_PROFILE) $(SACOMP_DEBUG)

	$(RM) config.platform

	$(RM) resources/*/bin/LIBCHARS

	$(RM) emacs/*.elc
	$(RM) emacs/*.info emacs/*.info??

	debian/rules clean-safe

=== test/Makefile ===
export SATHER_HOME=$(shell cd ..;pwd)
export LOCALE=en_NZ
export SATHER_ENV=$(SATHER_HOME)/resources/$(LOCALE)/bin/LIBCHARS

#CS_OPT=-chk -verbose -only_reachable -pretty
CS_OPT=-verbose -only_reachable -chk
SACOMP=$(SATHER_HOME)/bin/sacomp

default: do_test do_std_chans do_all

do_%: test_%
	./test_$(*) | tee test_$(*).output

test_test: FORCE
#	$(SACOMP) test.module -o test_test -main TEST_TEST $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_test.code

test_std_chans: FORCE
#	$(SACOMP) test.module -o test_std_chans -main TEST_STD_CHANS $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_std_chans.code

test_all: FORCE
#	$(SACOMP) test.module -o test_all -main TEST_ALL $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_all.code

test_minimal: FORCE
	$(SACOMP) test.module -o test_minimal -main TEST_MINIMAL $(CS_OPT) -only_C
	$(MAKE) CFLAGS="-I. -g" -C test_minimal.code

FORCE:

clean:
	rm -rf test_test.code test_std_chans.code test_all.code test_minimal.code
	rm -f test_test test_std_chans test_all test_minimal
	rm -f *.output

=== platforms/X/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:	
clean:
test:

=== system/am/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SATHER_HOME=$(shell cd ../..;pwd)

include $(SATHER_HOME)/config.default

LIBNAME=am_$(ARCH).a
LIBDIR=../lib
HEADERNAME=am.h
HEADERDIR=../include
#Nobbi:
PCFLAGS=-g -Wall -DAM_THREADS -DLWP -I../include
PLIBS=$(SATHER_HOME)/system/lib/lwp.a

CFLAGS+=$(PCFLAGS) $(AM) -I$(HEADERDIR)
LIBS=-L$(LIBDIR) $(PLIBS)

AMCFILES=am.c am_add.c am.h am_int.h mesg.c \
         am_nothread.c am_lwp.c am_solaris.c am_linux.c am_win32.c \
	 am_tcp.c am_lanai.c am_meiko.c 

OBJ=am.o am_tcp.o am_add.o am_meiko.o am_lanai.o am_lwp.o am_solaris.o am_linux.o \
    am_win32.o am_nothread.o

default: $(LIBNAME)

$(LIBNAME): $(OBJ) Makefile
	$(RM) -f $(LIBNAME)
	$(AR) rcs $(LIBNAME) $(OBJ)

install: $(LIBNAME) Makefile
	$(CP) $(LIBNAME) $(LIBDIR)/$(LIBNAME)
	$(CP) am.h $(HEADERDIR)/$(HEADERNAME)

am.o:		Makefile am.c am.h am_int.h
am_nothread.o:	Makefile am_nothread.c am.h am_int.h
am_lwp.o:	Makefile am_lwp.c am.h am_int.h
am_tcp.o:	Makefile am_tcp.c am.h am_int.h
am_add.o:	Makefile am_add.c am.h am_int.h
am_lanai.o:	Makefile am_lanai.c am.h am_int.h # ../config/lanai/lcp/ep.h ../config/lanai/lcp/ifc.h 
am_meiko.o:	Makefile am_meiko.c am.h am_int.h
am_solaris.o:	Makefile am_solaris.c am.h am_int.h
am_linux.o:	Makefile am_linux.c am.h am_int.h
am_win32.o:	Makefile am_win32.c am.h am_int.h

mesg.o:		Makefile mesg.c am.h

clean:
	$(RM) -f *.o am_*.a mesg

test: mesg Makefile
#	@-echo "*** The Library is now beeing tested."
#	@-echo "*** On a slow system the test will run for several minutes"
#	$(AM_TEST)
mesg: mesg.o $(LIBNAME) am.h $(OBJ) $(LWP)
	$(CC) $(CFLAGS) -o mesg mesg.o $(OBJ) $(LIBS)

=== platforms/solaris/smp_zones/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:
	@ echo Making Siva smp_solaris library
	$(MAKE) -C ../../../system/siva smp_solaris INSTALL=smp_solaris.a

clean:
test:

=== system/activethreads/ConjunctiveLocks/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Tests
INC_DIR	      = -I. -I../include -I../md/$(ARCH)
CC	      = gcc 
#To disable inlining, use -DAT_NO_INLINE
#CFLAGS	      = $(INC_DIR) -g -DAT_NO_INLINE
CFLAGS	      = $(INC_DIR) -g -O3
SRC_HDRS      = ../include/at.h ../include/at-inline.h
LOCAL_HDRS    = ./at_c_locks.h
ALL_HDRS      = $(SRC_HDRS) $(LOCAL_HDRS)
LDFLAGS	      = $(CFLAGS) 
OBJS          = at_c_locks_man.o at_c_locks.o
LIBS	      = ../lib/libat.a ../lib/libqt.a ../lib/libschedulers.a
#EXT_LIBS      = -lkstat -lm
EXT_LIBS      = -lm 
LINKER	      = $(CC)
AT_H		= ../include/at.h

test_files    = at_c_locks_test_mutex \
                at_c_locks_test_rw \
                at_c_locks_test_c_mutex_8 \
                at_c_locks_benchmark

tests:		$(test_files)
		./at_c_locks_test_mutex
		./at_c_locks_test_rw
		./at_c_locks_test_c_mutex_8
		./at_c_locks_benchmark

at_c_locks.o:             $(ALL_HDRS) at_c_locks.c
at_c_locks_man.o:         $(ALL_HDRS) at_c_locks.c
at_c_locks_test_mutex.o:  $(ALL_HDRS) at_c_locks_test_mutex.c
at_c_locks_test_rw.o:     $(ALL_HDRS) at_c_locks_test_rw.c
at_c_locks_test_mutex.o:  $(ALL_HDRS) at_c_locks_test_mutex.c
at_c_locks_benchmark.o:   $(ALL_HDRS) at_c_locks_benchmark.c


at_c_locks_test_mutex:	$(LIBS) at_c_locks_test_mutex.o $(OBJS)
		$(LINKER) at_c_locks_test_mutex.o $(OBJS) $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_c_locks_test_mutex

at_c_locks_test_rw:	$(LIBS) at_c_locks_test_rw.o $(OBJS)
		$(LINKER) at_c_locks_test_rw.o $(OBJS) $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_c_locks_test_rw

at_c_locks_test_c_mutex_8:	$(LIBS) at_c_locks_test_c_mutex_8.o $(OBJS)
		$(LINKER) at_c_locks_test_c_mutex_8.o $(OBJS) $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_c_locks_test_c_mutex_8

at_c_locks_benchmark:	$(LIBS) at_c_locks_benchmark.o $(OBJS)
		$(LINKER) at_c_locks_benchmark.o $(OBJS) $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_c_locks_benchmark

clean:		
		rm -f $(test_files)
		rm -f *.o

=== system/activethreads/src/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

SATHER_HOME=$(shell cd ../../..;pwd)

include $(SATHER_HOME)/config.default

ARCHITECTURES=osf_axp_smp_at \
	      hppa_hpux_smp_at \
	      linux_smp_at \
	      solaris_x86 \
	      cygwin_smp_at \
	      mips_irix5 \
	      solaris_sparc_smp

LIBDEST=../../lib
INCLUDEDEST=../../include

# At least -O or higher is needed for inlining to work properly
# in gcc

#To enable inlining, comment out DEBUG_FLAGS
#If you do this, make sure -O or higher is used
#(gcc fails to do inilining otherwise)
DEBUG_FLAGS   =-g -DAT_NO_INLINE
#DEBUG_FLAGS   =-O3
CFLAGS	      =$(DEBUG_FLAGS) -DAT_$(ARCH) -I. -I ../schedulers


HEADERS=at-inline.h \
	at-int.h \
	at-lwp.h \
	at.h \
	bundle.h \
	cond.h \
	const.h \
	md-atomic.h \
	md-lwp.h \
	md-qtmd.h \
	md-utils.h \
	mutex.h \
	p_pool.h \
	pool.h \
	qt.h \
	sema.h \
	spinlock.h \
	thread.h \
	wrappers.h
#	barrier.h \
#	rw.h




ARCH_HDRS=     $(ARCH)/qtmd.h \
               $(ARCH)/utils.h \
               $(ARCH)/lwp.h \
               $(ARCH)/md-atomic.h

LDFLAGS	 =$(CFLAGS)
LINKER	 =$(CC)
OBJS     =$(ARCH)/qtmdb.o meas.o

# Temporarily disabled hardware feedback */
#QTOBJS =qt.o $(ARCH)/qtmds.o $(ARCH)/hwperf.o
QTOBJS =qt.o $(ARCH)/qtmds.o

ATOBJS =at.o mutex.o cond.o pool.o p_pool.o sema.o \
        wrappers.o $(ARCH)/lwp.o thread.o
#        barrier.o rw.o

QT_H   =qt.h $(QTMD_H)
QTMD_H =$(ARCH)/qtmd.h

#############################################################

default: qt_$(ARCH).a at_$(ARCH).a

#    'all' apparently omitted!!
all:     default

install: all
	cp $(HEADERS) $(INCLUDEDEST)
	@for i in $(ARCHITECTURES) ; do \
		if [ -e at_$$i.a ] ; then \
			cp at_$$i.a $(LIBDEST)/libat.a ; \
			cp qt_$$i.a $(LIBDEST)/libqt.a ; \
			mkdir $(INCLUDEDEST)/$$i ; \
			cp $$i/*.h $(INCLUDEDEST)/$$i ; \
		fi ; \
	done

qtmdb.o: qtmdb.s b.h
meas.o: meas.c $(QT_H) b.h at.h
qt.o: qt.c $(QT_H)
at.o: at.c at.h $(QT_H)

at.h: at-inline.h wrappers.h mutex.h cond.h sema.h \
#      barrier.h rw.h
at-int.h: qt.h spinlock.h at.h at-inline.h at-lwp.h mutex.h cond.h const.h \
          pool.h p_pool.h $(ARCH)/utils.h thread.h wrappers.h \
#          rw.h

pool.h:		spinlock.h wrappers.h
p_pool.h:	pool.h spinlock.h wrappers.h
bundle.h:	at-int.h

at.o:		at-int.h at.c
mutex.o:	at-int.h mutex.c
cond.o:		at-int.h cond.c
# rw.o:		at-int.h rw.c
pool.o:		pool.h pool.c
p_pool.o:	p_pool.h p_pool.c
sema.o:		at-int.h sema.c
# barrier.o:	at-int.h barrier.c

thread.o: at-int.h thread.c
wrappers.o: spinlock.h wrappers.c

$(ARCH)/qtmds.o: $(ARCH)/qtmds.s
        $(MAKE) -C ARCH=$(ARCH) qtmds.o

$(ARCH)/hwperf.o:
        $(MAKE) -C ARCH=$(ARCH) hwperf.o

$(ARCH)/lwp.o: $(ARCH)/lwp.h wrappers.h $(ARCH)/lwp.c
        $(MAKE) -C ARCH=$(ARCH) lwp.o

qt_$(ARCH).a: $(QTOBJS)
	$(AR) crvs qt_$(ARCH).a $(QTOBJS)

at_$(ARCH).a: $(ATOBJS)
	$(AR) crvs at_$(ARCH).a $(ATOBJS)

clean:
	rm -f *.o
	rm -f */*.o
	rm -f qt_*.a at_*.a

=== system/activethreads/tests/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

VPATH    =.:../include
# Tests
INC_DIR  =-I. -I../include -I../md/$(ARCH)
CC       =gcc
#To disable inlining, use -DAT_NO_INLINE
CFLAGS   =$(INC_DIR) -g -DAT_NO_INLINE
#CFLAGS   =$(INC_DIR) -O3 -g
SRC_HDRS =at.h at-inline.h
LDFLAGS	 =$(CFLAGS)
LIBS     =../lib/libat.a ../lib/libschedulers.a ../lib/libqt.a
#EXT_LIBS =-lkstat -lm
EXT_LIBS =-lm -lpthread
LINKER   =$(CC)
AT_H     =at.h

test_files =at_create at_null_thread at_rec_create at_test_create at_cswitch \
            at_ping_pong_mutex at_ping_pong_sema at_uncontested_mutex at_uncontested_sema \
            at_mutex_try at_sema_try at_cond at_qsort at_merge at_barrier \
            at_producer at_vm at_mm at_gauss \
#            at_native_barrier at_rw at_photo

tests: $(test_files)
	./at_create
	./at_null_thread
	./at_rec_create
	./at_test_create
	./at_cswitch
	./at_ping_pong_mutex
	./at_ping_pong_sema
	./at_uncontested_mutex
	./at_uncontested_sema
	./at_mutex_try
	./at_sema_try
	./at_cond
#	./at_rw
	./at_qsort 
	./at_merge 
	./at_vm
	./at_mm


at_vm.o: $(AT_H) at_vm.c
at_mm.o: $(AT_H) at_mm.c
at_gauss.o: $(AT_H) at_gauss.c
at_qsort.o: $(AT_H) at_qsort.c
at_merge.o: $(SRC_HDRS) at_merge.c
#at_photo.o: $(SRC_HDRS) at_photo.c
at_tasks.o: $(SRC_HDRS) at_tasks.c
at_flat_merge.o: $(SRC_HDRS) at_flat_merge.c
at_cswitch.o: $(AT_H) at_cswitch.c
at_cond.o: $(AT_H) at_cond.c
#at_rw.o: $(AT_H) at_rw.c
at_barrier.o: $(AT_H) at_barrier.c
#at_native_barrier.o: $(AT_H) at_native_barrier.c
at_create.o: $(AT_H) at_create.c
at_rec_create.o: $(AT_H) at_rec_create.c
at_ping_pong_mutex.o: $(AT_H) at_ping_pong_mutex.c
at_ping_pong_sema.o: $(AT_H) at_ping_pong_sema.c
at_producer.o: $(AT_H) at_producer.c
at_uncontested_mutex.o: $(AT_H) at_uncontested_mutex.c
at_uncontested_sema.o: $(AT_H) at_uncontested_sema.c
at_test_create.o: $(AT_H) at_test_create.c
at_test_create.o: $(AT_H) at_switch_to_self.c
at_affinity.o: $(AT_H) at_affinity.c
at_mutex_try.o: $(AT_H) at_mutex_try.c
at_sema_try.o: $(AT_H) at_sema_try.c
at_grain.o: $(AT_H) at_grain.c

ch.o: $(AT_H) ch.c
ch: ch.o
	$(LINKER) ch.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o ch

michael.o: $(AT_H) michael.c
michael: michael.o
	$(LINKER) michael.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o michael

se.o: $(AT_H) se.c
se: se.o
	$(LINKER) se.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o se

at_merge: at_merge.o
	$(LINKER) at_merge.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_merge 
at_flat_merge: at_flat_merge.o
	$(LINKER) at_flat_merge.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_flat_merge 

#at_photo: at_photo.o
#	$(LINKER) at_photo.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_photo

at_tasks: at_tasks.o
	$(LINKER) at_tasks.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_tasks

at_vm: $(LIBS) at_vm.o
	$(LINKER) at_vm.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_vm 

at_mm: $(LIBS) at_mm.o
	$(LINKER) at_mm.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_mm 

at_gauss: $(LIBS) at_gauss.o
	$(LINKER) at_gauss.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_gauss 

at_qsort: $(LIBS) at_qsort.o
	$(LINKER) at_qsort.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_qsort 

at_cswitch: $(LIBS) at_cswitch.o
	$(LINKER) at_cswitch.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_cswitch 

at_cond: $(LIBS) at_cond.o
	$(LINKER) at_cond.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_cond 

#at_rw: $(LIBS) at_rw.o
#	$(LINKER) at_rw.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_rw 

at_create: $(LIBS) at_create.o
	$(LINKER) at_create.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_create 

at_null_thread:	$(LIBS) at_null_thread.o
	$(LINKER) at_null_thread.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_null_thread 

at_rec_create: $(LIBS) at_rec_create.o
	$(LINKER) at_rec_create.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_rec_create 

at_mutex_try: $(LIBS) at_mutex_try.o
	$(LINKER) at_mutex_try.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_mutex_try 

at_sema_try: $(LIBS) at_sema_try.o
	$(LINKER) at_sema_try.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_sema_try 

at_barrier: $(LIBS) at_barrier.o
	$(LINKER) at_barrier.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_barrier 

#at_native_barrier: $(LIBS) at_native_barrier.o
#	$(LINKER) at_native_barrier.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_native_barrier 

at_ping_pong_mutex: $(LIBS) at_ping_pong_mutex.o
	$(LINKER) at_ping_pong_mutex.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_ping_pong_mutex 

at_ping_pong_sema: $(LIBS) at_ping_pong_sema.o
	$(LINKER) at_ping_pong_sema.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_ping_pong_sema

at_producer: $(LIBS) at_producer.o
	$(LINKER) at_producer.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_producer

at_uncontested_mutex: $(LIBS) at_uncontested_mutex.o
	$(LINKER) at_uncontested_mutex.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_uncontested_mutex

at_uncontested_sema: $(LIBS) at_uncontested_sema.o
	$(LINKER) at_uncontested_sema.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_uncontested_sema

at_test_create:	$(LIBS) at_test_create.o
	$(LINKER) at_test_create.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_test_create

at_switch_to_self: $(LIBS) at_switch_to_self.o
	$(LINKER) at_switch_to_self.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_switch_to_self

at_affinity: $(LIBS) at_affinity.o
	$(LINKER) at_affinity.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_affinity

at_grain: $(LIBS) at_grain.o
	$(LINKER) at_grain.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o at_grain

t1: $(LIBS) t1.o
	$(LINKER) t1.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o t1


# This test was initially written to use Solaris threads.
# Until I have the time to change it to Active Threads, it will stay
# this way. Feel free to change it - it should be pretty easy ;-)
pool_test: thread.h thread.c pool_test.c pool.o
	gcc -O -g -I. -D_REENTRANT thread.c pool_test.c pool.o -o pool_test -lposix4 -lthread

test_pool.o: $(AT_H) test_pool.c
test_pool: $(LIBS) test_pool.o
	$(LINKER) test_pool.o $(LDFLAGS) $(LIBS) $(EXT_LIBS) -o test_pool

clean:
	rm -f $(test_files)
	rm -f *.o

=== system/activethreads/src/solaris_sparc_smp/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

AS     =gcc
CC     =gcc
CPP    =/lib/cpp
# -Wa,-xarch=v8plusa must be used to generate code for access to 
# UltraSPARC performance counters
#CFLAGS =-I. -I../../include -g -O -Wa,-xarch=v8plusa
CFLAGS =-I. -I.. -g -O

qtmds.o: qtmds.s
	$(AS) -c qtmds.s

lwp.o: lwp.h lwp.c

hwperf.o: hwperf_src.s
	$(CPP) hwperf_src.s > hwperf.s
	gcc -c -Wa,-xarch=v8plusa hwperf.s -o hwperf.o

clean:
	rm *.o

=== system/brahma/arch_solaris_myrinet/src/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Make sure MYRI_HOME is set!

#ICSI Myrinet home directory
MYRI_HOME = /u/sather/network/myrinet
#MYRI_HOME = /disks/barad-dur/now/CAL/myricom/myrinet.2.2a
#MYRI_HOME =  /disks/barad-dur/now/CAL/myricom/myrinet.3.04f-gam
#MYRI4_HOME = /disks/barad-dur/now/share/src/AM/am2-myricom-304f

LIB_DIR    = ../../library

#LANai3 compiler home directory
MYRI4_HOME = /u/sather/network/myricom-308

#MYRI4_HOME = /disks/barad-dur/now/share/src/AM/am2-myricom-304j

SRC_FILTER= l4lcp.c lcp.c l4lcp.c

#needed because I am too lazy to change this Makefile. 
# used to set GAM type, e.g. TCPAM, PAM etc. 
MPL = LAM

BIN = ../bin
LIB = ../lib
DEP = Make.depend

CC = gcc
# C flags if using glunix
# The flags: 
# USE_LANAI4: A Must 
# SOLARIS: A Must 
# USE_GLUNIX: Optional if you want to use glunix
# DEBUG: Optional. Highly recommended! 
# 
#CFLAGS = -DUSE_LANAI4 -DSOLARIS -DDEBUG -g -O4 -fschedule-insns2  -fexpensive-optimizations  -DUSE_GLUNIX -I. 

#cflags if not using glunix
#CFLAGS = -DUSE_LANAI4 -DSOLARIS -D_REENTRANT -DBR_MYRINET_SOLARIS -O4 -fschedule-insns2 -fexpensive-optimizations -I. 

#No optimizations for debugging
CFLAGS = $(THREAD_FLAGS) -DUSE_LANAI4 -DDEBUG -g -I. -Winline -I${MYRI_HOME}/include -I../.. 

#Use optimizations 
#CFLAGS = $(THREAD_FLAGS) -DUSE_LANAI4 -O4 -fschedule-insns2 -fexpensive-optimizations  -I. -I${MYRI_HOME}/include -I../.. 


# source/object files, libs, and includes
#
.SUFFIXES : .c .o .lan_o .lan_s .dat

#Magic. Do not mess with this unless you know what you're doing. 


#LIBS = ${LIB}/lib${MPL}.a ${LIB}/libAM1-5.a 
LIBS = ${LIB}/lib${MPL}.a 
INCS	= ${filter-out %_int.h, ${wildcard *.h}}
INSTALL_INCS = ${filter-out ${INCS_FILTER}, ${wildcard *.h}}

#COMMON_OBJS =  ${BIN}/am_glib.o  ${BIN}/lam_common.o 
COMMON_OBJS =  ${BIN}/lam_common.o 
LAM_OBJS =  ${BIN}/lam.o  ${BIN}/lam_barrier.o 
SYNC_OBJS = 
#AM15_OBJS =  ${BIN}/am1-5.o 

.PHONY: default clean clear depend  distclean

# Lanai stuff 

LANAI_HDRS = ep.h

LANAI4_INC = -I${MYRI4_HOME}/include 
CCLAN3     = /u/sather/network/myricom-308/bin/lanai3-gcc 


default: ${BIN} depend ${LIBS} 

# Do not change the -O0 flag unless you know what you're doing. 
l4lcp:  ep.h l4lcp.c 
	${CCLAN3} -m4.1 -O0 -DLANAI4 -DDEBUG ${LANAI4_INC} -o l4lcp l4lcp.c 

#l4lcp:  ep.h l4lcp.c 
#	${CCLAN3} -m4.1 -O2 -DLANAI4 ${LANAI4_INC} -o l4lcp l4lcp.c 

#l4lcp for use of big-contexts (timed, g is same, L slower. )
#l4lcp:  ep.h l4lcp.c 
#	${CCLAN3} -m4.1 -mbig-contexts -O2 -DBIG_CONTEXTS -DLANAI4 ${LANAI4_INC} -o l4lcp l4lcp.c lcp_utils.s

clean: 
	rm -f ${BIN}/*.o ${LIB}/*.a l4lcp

clear distclean:
	rm -rf ${BIN} ${LIB}

# dependencies
#
${LIBS}: ${OBJ}

# rules for the bin directory
${BIN}:
	mkdir $@

# rules for the library directory
${LIB}:
	mkdir $@

# rules for the library
#${LIB}/%.a:
#	ar cru $@ $^

${LIB}/lib${MPL}.a: ${COMMON_OBJS} ${LAM_OBJS}
	ar cru $@ ${COMMON_OBJS} ${LAM_OBJS}

#${LIB}/libAM1-5.a:  ${COMMON_OBJS} ${AM15_OBJS}
#	ar cru $@ ${COMMON_OBJS} ${AM15_OBJS}


#may or may not work. 
install:
	cp ${LIBS} ${SC_ROOT}/${MPL}/lib


INSTALL = ../lib/libLAM.a
MYRI_BIN_DIR = ../bin
MYRI_SRC = lam_common.c lam.c lam_barrier.c myrinet_solaris.c

${MYRI_BIN_DIR}/%.o: %.c 
	${CC} ${CFLAGS} -o $@ -c $<
${MYRI_BIN_DIR}/%.o: %.s
	${CC} ${CFLAGS}  -o $@ -c $<

solaris_sparc: $(MYRI_BIN_DIR)/lam_common.o $(MYRI_BIN_DIR)/lam.o $(MYRI_BIN_DIR)/lam_threads.o $(MYRI_BIN_DIR)/lam_barrier.o $(MYRI_BIN_DIR)/brahma.o
	ar rus ../../$(INSTALL) $(MYRI_BIN_DIR)/lam_common.o \
			  $(MYRI_BIN_DIR)/lam.o \
			  $(MYRI_BIN_DIR)/lam_threads.o \
			  $(MYRI_BIN_DIR)/lam_barrier.o \
			  $(MYRI_BIN_DIR)/brahma.o 
	rm $(MYRI_BIN_DIR)/*.o

solaris_at_sparc: $(MYRI_BIN_DIR)/lam_common.o $(MYRI_BIN_DIR)/lam.o $(MYRI_BIN_DIR)/at_threads.o $(MYRI_BIN_DIR)/lam_barrier.o $(MYRI_BIN_DIR)/brahma.o
	ar rus ../../$(INSTALL) $(MYRI_BIN_DIR)/lam_common.o \
			  $(MYRI_BIN_DIR)/lam.o \
			  $(MYRI_BIN_DIR)/at_threads.o \
			  $(MYRI_BIN_DIR)/lam_barrier.o \
			  $(MYRI_BIN_DIR)/brahma.o 
	rm $(MYRI_BIN_DIR)/*.o	

#to make pmake happy...
$(MYRI_BIN_DIR)/lam_common.o:  lam_common.c
	$(CC) -c $(CFLAGS) lam_common.c -o $(MYRI_BIN_DIR)/lam_common.o
$(MYRI_BIN_DIR)/lam.o:  lam.c
	$(CC) -c $(CFLAGS) lam.c -o $(MYRI_BIN_DIR)/lam.o
$(MYRI_BIN_DIR)/lam_threads.o:  lam_threads.c
	$(CC) -c $(CFLAGS) lam_threads.c -o $(MYRI_BIN_DIR)/lam_threads.o
$(MYRI_BIN_DIR)/at_threads.o:  at_threads.c
	$(CC) -c $(CFLAGS) at_threads.c -o $(MYRI_BIN_DIR)/at_threads.o
$(MYRI_BIN_DIR)/lam_barrier.o:  lam_barrier.c
	$(CC) -c $(CFLAGS) lam_barrier.c -o $(MYRI_BIN_DIR)/lam_barrier.o
$(MYRI_BIN_DIR)/brahma.o: ../../brahma.c
	gcc -c $(CFLAGS) $(INC_FLAGS) ../../brahma.c -o $(MYRI_BIN_DIR)/brahma.o

=== system/psather/test/sort/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

#
# Some install variables
#

include ../../Make.config
include ../../pSather.options
HEADERDIR=../../include
LIBDIR=../../lib
PSATHERLIB=$(LIBDIR)/libpSather.a
CFLAGS=$(PCFLAGS) $(PSATHER) -I$(HEADERDIR) 
LFLAGS=-L$(LIBDIR) -lpSather -lam $(PLIBS)

sort:	sort.o mktable.o sort.h $(PSATHERLIB)
	gcc -o sort -g sort.o mktable.o $(LFLAGS)

$(PSATHERLIB):	../../pSather.options
		cd ../../pSather ; $(MAKE) install ; cd ../test/sort

mktable.o:	mktable.c sort.h
sort.o:		sort.c sort.h

clean:
	@-rm *.o 2> /dev/null

.c.o:;
	gcc $(CFLAGS) -c $*.c

=== debian/changelog ===
sather (1.3.beta3-1) unstable; urgency=low

  * New upstream version

 -- Norbert Nemec <nobbi@gnu.org>  Wed, 3 Nov 1999 23:16:07 +0200

sather (1.2.1-1) unstable; urgency=low

  * New upstream version

 -- Norbert Nemec <nobbi@gnu.org>  Wed, 3 Nov 1999 23:16:07 +0200

sather (1.2.0-1) unstable; urgency=low

  * New upstream version
  * Changing from /usr/lib/Sather to /usr/lib/sather

 -- Norbert Nemec <nobbi@gnu.org>  Tue, 13 Oct 1999 9:38:17 +0200

sather (1.2.pre4-1) unstable; urgency=low

  * New upstream version

 -- Norbert Nemec <nobbi@gnu.org>  Tue, 14 Sept 1999 15:21:50 +0200

sather (1.2-1) unstable; urgency=low

  * New upstream version ( Working towards GNU Sather )

 -- Norbert Nemec <nobbi@gnu.org>  Sun, 25 Jul 1999 16:21:50 +0200

sather (1.2b-2) unstable; urgency=low

  * Fixing stuff up to get first preliminary version out.

 -- Norbert Nemec <nobbi@gnu.org>  Thu, 20 May 1999 22:43:08 +0200

sather (1.2b-1) unstable; urgency=low

  * Removed GC from package, now depends on libgc4
  * Initial Release.

 -- Norbert Nemec <nobbi@gnu.org>  Tue,  23 Feb 1999 13:07:50 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address: "nobbi@gnu.org"
End:

=== debian/control ===
Source: sather
Section: devel
Priority: optional
Maintainer: Norbert Nemec <nobbi@gnu.org>
Standards-Version: 2.4.0.0

Package: sather
Architecture: any
Depends: sather-common, libgc-dev, ${shlibs:Depends}
Suggests: tk8.0-dev
Provides: sacomp
Description: GNU Sather compiler and library
 Compiler and programming environment for Sather:
 Sather is an object oriented language which designed to be simple,
 efficient, safe, and non-proprietary. It aims to meet the needs of
 modern research groups and to foster the development of a large,
 freely available, high-quality library of efficient well-written
 classes for a wide variety of computational tasks. It was originally
 based on Eiffel but now incorporates ideas and approaches from several
 languages. One way of placing it in the "space of languages" is to say
 that it attempts to be as efficient as C, C++, or Fortran, as elegant
 and safe as Eiffel or CLU, and to support higher-order functions as
 well as Common Lisp, Scheme, or Smalltalk.

Package: sather-boot
Architecture: any
Depends: sather-common, libgc-dev, ${shlibs:Depends}
Suggests: tk8.0-dev
Provides: sacomp
Description: Old Sather compiler and library
 This is the Sather compiler using the old (pre-Waikato) library. It is 
 provided for compiling old code (and because the new library has not 
 yet reached much stability)

Package: sather-common
Architecture: all
Depends: sacomp, ${shlibs:Depends}
Description: Common files for both Sather versions

Package: sather-par
Architecture: any
Depends: sather
Description: pSather - Parallel extensions to the Sather environment
 There are two implementations included in this package:
 One based upon LWP, a implementation of user-space threads, which is also
 included in this package.
 The other based upon ActiveThreads LWP, a implementation based upon POSIX 
 threads, which is also included in this package.

Package: sather-doc
Architecture: all
Suggests: sather, www-browser, postscript-viewer, info-browser
Description: Documentation for the object oriented language Sather
 HTML, PostScript, Info documentation for the object oriented language
 Sather.

Package: sather-elisp
Architecture: all
Depends: emacsen
Suggests: sather
Description: Emacs mode for editing Sather programs
 Emacs mode for editing Sather programs.

Package: sather-browser
Architecture: any
Depends: sather, c-shell, tclsh, ${shlibs:Depends}
Description: A Tcl/Tk based class browser for Sather.
 A class browser for the OO-language Sather, written in Sather, using the 
 Tcl/Tk toolkit.

=== debian/rules ===
#!/usr/bin/make -f
############################################################################
# Made with the aid of dh_make, by Craig Small
# Based on sample debian/rules that uses debhelper,  by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.
# Based on a earlier version by Shugo Maeda
# Completely reworked and turned upside down by Norbert Nemec
############################################################################

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

pwd := $(shell pwd)

###################

sather_root  := $(pwd)/debian/tmp
sather_home  := $(sather_root)/usr/lib/sather
sather_bin   := $(sather_root)/usr/bin

sather_files := bin/sacomp \
		lib \
		resources \
		system/CONFIG

###################

boot_root  := $(pwd)/debian/sather-boot
boot_home  := $(boot_root)/usr/lib/sather
boot_bin   := $(boot_root)/usr/bin

boot_files := bin/sacomp-boot \
		lib-boot \
		system/CONFIG-boot \
		system/debug \
		system/old-runtime

###################

common_root  := $(pwd)/debian/sather-common
common_home  := $(common_root)/usr/lib/sather

common_files := system/FORBID \
		platforms/X \
		platforms/dualgui \
		platforms/f77 \
		platforms/gui \
		platforms/linux \
		platforms/tcltk

###################

par_root    := $(pwd)/debian/sather-par
par_home    := $(par_root)/usr/lib/sather

par_files   := platforms/linux/smp \
               platforms/linux/lwp \
	       system/lib \
               system/include

###################

doc_root    := $(pwd)/debian/sather-doc
doc_dir     := $(doc_root)/usr/doc/sather-doc
doc_info    := $(doc_root)/usr/info

info_files  := sather.info sather.info-1 sather.info-2 sather-tutorial.info

###################

el_root    := $(pwd)/debian/sather-elisp
el_install := $(el_root)/usr/lib/emacsen-common/packages/install
el_remove  := $(el_root)/usr/lib/emacsen-common/packages/remove
el_dir     := $(el_root)/usr/share/emacs/site-lisp/sather-elisp
el_etc     := $(el_root)/etc/emacs/site-start.d
el_info    := $(el_root)/usr/info

el_files   := emacs/sather.el emacs/sather-module.el emacs/sather-lib.el

###################

browser_root := $(pwd)/debian/sather-browser
browser_home := $(browser_root)/usr/lib/sather

browser_files := bin/sabrowse bin/gen_html sabrowse/tcl sabrowse/web

############################################################################

all:

###################

build: build-force build-stamp
build-force:
	rm -f build-stamp
build-stamp:
#	dh_testversion
	dh_testdir
	dh_testroot
	
	./configure linux
	$(MAKE)
	$(MAKE) optional
	$(MAKE) info
	
	touch build-stamp

###################

install: install-force install-stamp
install-force:
	rm -f install-stamp
install-stamp: build-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
	##### General preparations for installing
	
	dh_clean -k
	dh_installdirs
	
	##### Installing: sather
	
	for file in $(sather_files); do \
	  cp -a -P $$file $(sather_home); \
	done
	
	rm -r `find $(sather_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" ")"`

	ln -s ../lib/sather/bin/bin-wrapper $(sather_root)/usr/bin/sacomp
	
	##### Installing: sather-boot
	
	for file in $(boot_files); do \
	  cp -a -P $$file $(boot_home); \
	done
	
	rm -r `find $(boot_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" ")"`

	ln -s ../lib/sather/bin/bin-wrapper $(boot_root)/usr/bin/sacomp-boot
	
	##### Installing: sather-common
	
	for file in $(common_files); do \
	  cp -a -P $$file $(common_home); \
	done
	
	rm -r `find $(common_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" ")"`
	rm -r $(sather_home)/platforms/linux/lwp
	
	install -m755 debian/bin-wrapper $(sather_home)/bin
	
	dh_installmanpages -psather-common sabrowse.1 shortflat.1 tgrep.1
	dh_installchangelogs -psather-common doc/Changes
	
	##### Installing: sather-par
	
	for file in $(par_files); do \
	  cp -a -P $$file $(par_home); \
	done
	
	rm $(par_home)/platforms/linux/lwp/Makefile

	rm -r `find $(par_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" -o -name "PP" ")"`
	
	##### Installing: sather-browser
	
	for file in $(browser_files); do \
	  cp -a $$file $(browser_home)/$$file; \
	done
	
	ln -s ../lib/sather/bin/bin-wrapper $(browser_root)/usr/bin/sabrowse
	
	rm -r `find $(browser_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" -o -name "PP" ")"`
	
	dh_installmanpages -psather-browser sacomp.1 shortflat.1 tgrep.1
	dh_installchangelogs -psather-browser
	
	##### Installing: sather-doc
	
	for file in $(info_files); do \
	    cp -a emacs/$$file $(doc_info); \
	done
	
	dh_installchangelogs -psather-doc
	
	# Installing: sather-elisp
	
	cp -a $(el_files) $(el_dir)
	cp -a debian/50sather.el $(el_etc)
	cp -a emacs/sather-mode.info $(el_info)
	
	dh_installchangelogs -psather-elisp emacs/ChangeLog
	
	
	##### General finishing commands
	
	dh_installdocs
	dh_installemacsen
	
#	dh_installexamples
#	dh_installmenu
	
	dh_strip
	dh_compress
	dh_fixperms
	
	touch install-stamp

###################
	
# Build architecture-independent files here.
binary-indep: install-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
#	dh_suidregister -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_makeshlibs -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
binary-arch: install-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
#	dh_suidregister -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_makeshlibs -a
	dh_md5sums -a
	dh_builddeb -a


binary: binary-indep binary-arch

###################

clean: clean-internal
	$(MAKE) clean

clean-internal:
#	dh_testversion
	dh_testdir
	dh_testroot
	
	rm -f *-stamp
	
	dh_clean

# Meant for being called on any system (even non-Debian) without
# errors
clean-safe:
	if [ -x /usr/bin/dh_clean ] ; then                     \
	  if [ "$$UID" != "0" -a -x /usr/bin/fakeroot ] ; then \
	    fakeroot debian/rules clean-internal ;             \
	  else                                                 \
	    debian/rules clean-internal ;                      \
	  fi ;                                                 \
	fi

###################

test:
#	dh_testversion
	dh_testdir
	dh_testroot

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

.PHONY: build build-force install install-force \
	binary-indep binary-arch binary \
	clean test

############################################################################
